Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.poi
Class POIXMLDocument

    java.lang.Object
      org.apache.poi.POIXMLDocumentPart
          org.apache.poi.POIXMLDocument

Direct Known Subclasses:
  XSLFSlideShow, XSSFWorkbook, XWPFDocument

    public abstract class POIXMLDocument

extends POIXMLDocumentPart

Field Summary
`static java.lang.String` | `DOCUMENT_CREATOR`
`static java.lang.String` | `OLE_OBJECT_REL_TYPE`
`static java.lang.String` | `PACK_OBJECT_REL_TYPE`

Fields inherited from class org.apache.poi.POIXMLDocumentPart
`DEFAULT_XML_OPTIONS`

Constructor Summary
`protected` | `POIXMLDocument(OPCPackage pkg)`

Method Summary
`abstract java.util.List<PackagePart>` | `getAllEmbedds()` Get the document's embedded files.
`protected PackagePart` | `getCorePart()`
`OPCPackage` | `getPackage()`
`POIXMLProperties` | `getProperties()` Get the document properties.
`protected PackagePart[]` | `getRelatedByType(java.lang.String contentType)` Retrieves all the PackageParts which are defined as relationships of the base document with the specified content type.
`protected static PackagePart` | `getTargetPart(OPCPackage pkg, PackageRelationship rel)` Get the PackagePart that is the target of a relationship.
`protected PackagePart` | `getTargetPart(PackageRelationship rel)` Get the PackagePart that is the target of a relationship.
`static boolean` | `hasOOXMLHeader(java.io.InputStream inp)` Checks that the supplied InputStream (which MUST support mark and reset, or be a PushbackInputStream) has a OOXML (zip) header at the start of it.
`protected void` | `load(POIXMLFactory factory)`
`static OPCPackage` | `openPackage(java.lang.String path)` Wrapper to open a package, returning an IOException in the event of a problem.
`void` | `write(java.io.OutputStream stream)` Write out this document to an Outputstream.

Methods inherited from class org.apache.poi.POIXMLDocumentPart
`addRelation, commit, createRelationship, createRelationship, createRelationship, getPackagePart, getPackageRelationship, getParent, getRelations, onDocumentCreate, onDocumentRead, onSave, read, rebase, removeRelation, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### DOCUMENT_CREATOR

    public static final java.lang.String DOCUMENT_CREATOR

See Also:
  Constant Field Values

### OLE_OBJECT_REL_TYPE

    public static final java.lang.String OLE_OBJECT_REL_TYPE

See Also:
  Constant Field Values

### PACK_OBJECT_REL_TYPE

    public static final java.lang.String PACK_OBJECT_REL_TYPE

See Also:
  Constant Field Values

Constructor Detail

### POIXMLDocument

    protected POIXMLDocument(OPCPackage pkg)

Method Detail

### openPackage

    public static OPCPackage openPackage(java.lang.String path)
                                  throws java.io.IOException

  Wrapper to open a package, returning an IOException in the event of a problem. Works around shortcomings in java's this() constructor calls

  Throws:
    `java.io.IOException`

### getPackage

    public OPCPackage getPackage()

### getCorePart

    protected PackagePart getCorePart()

### getTargetPart

    protected PackagePart getTargetPart(PackageRelationship rel)
                                 throws InvalidFormatException

  Get the PackagePart that is the target of a relationship.

  Parameters:
    `rel` - The relationship
  Returns:
    The target part
  Throws:
    `InvalidFormatException`

### getTargetPart

    protected static PackagePart getTargetPart(OPCPackage pkg,
                                               PackageRelationship rel)
                                        throws InvalidFormatException

  Get the PackagePart that is the target of a relationship.

  Parameters:
    `rel` - The relationship
    `pkg` - The package to fetch from
  Returns:
    The target part
  Throws:
    `InvalidFormatException`

### getRelatedByType

    protected PackagePart[] getRelatedByType(java.lang.String contentType)
                                      throws InvalidFormatException

  Retrieves all the PackageParts which are defined as relationships of the base document with the specified content type.

  Throws:
    `InvalidFormatException`

### hasOOXMLHeader

    public static boolean hasOOXMLHeader(java.io.InputStream inp)
                                  throws java.io.IOException

  Checks that the supplied InputStream (which MUST support mark and reset, or be a PushbackInputStream) has a OOXML (zip) header at the start of it. If your InputStream does not support mark / reset, then wrap it in a PushBackInputStream, then be sure to always use that, and not the original!

  Parameters:
    `inp` - An InputStream which supports either mark/reset, or is a PushbackInputStream
  Throws:
    `java.io.IOException`

### getProperties

    public POIXMLProperties getProperties()

  Get the document properties. This gives you access to the core ooxml properties, and the extended ooxml properties.

### getAllEmbedds

    public abstract java.util.List<PackagePart> getAllEmbedds()
                                                       throws OpenXML4JException

  Get the document's embedded files.

  Throws:
    `OpenXML4JException`

### load

    protected final void load(POIXMLFactory factory)
                       throws java.io.IOException

  Throws:
    `java.io.IOException`

### write

    public final void write(java.io.OutputStream stream)
                     throws java.io.IOException

  Write out this document to an Outputstream.

  Parameters:
    `stream` - - the java OutputStream you wish to write the file to
  Throws:
    `java.io.IOException` - if anything can't be written.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright 2010 The Apache Software Foundation or its licensors, as applicable.